import json
import uuid

from abc import ABC, abstractmethod

class Order(ABC):
    def __init__(self, orderId=uuid.uuid4(),
                 timestamp=datetime.datetime.now(datetime.timezone.utc)
                 userId=None, orderType=None, cardId=None, fee=0, transactions=[], data={}):
        self.orderId = orderId
        self.timestamp = timestamp
        self.userId = userId
        self.orderType = orderType
        self.cardId = cardId
        self.fee = fee
        self.transactions = transactions

    @abstractmethod
    def add_transaction(self, transaction):
        continue

    @abstractmethod
    def validate(self):
        continue

    @abstractmethod
    def load_from_data(self):
        continue
