###
# The OrderMatcher converts orders to transactions.
# When new orders arrive on the market, the order matcher is triggered to search the
# database for an existing order to fulfill the new one.
# If the order matcher finds a match for the order, it creates a transaction and
# sends it to the mine.
###

import requests

from Mine.Transaction import Transaction
from OrderMatcher.Database import Database

class OrderMatcher():
    def __init__(self):
        self.db = Database()

    def match_orders(self):
        try:
            for buyOrder in self.db.get_unfulfilled_buy_orders():
                for item in self.db.get_available_sell_order_items_for_buy_order(
                    buyOrder[0],
                    buyOrder[1]
                    )[:buyOrder[2]]:
                newTransaction = Transaction(
                    cardId = item[5],
                    sender = item[3],
                    receiver = currentUser, # TODO: get current currentUser
                    )
                newTransaction.sign(userPrivateKey) # TODO: get userPrivateKey
                r = requests.post(
                    f"{MINE_URL}/transactions",
                    data=str(newTransaction)
                    )
                # TODO: only insert on success
                self.db.insert_transaction(
                    newTransaction.transactionId,
                    buyOrder[0],
                    item[5]
                    )
        # TODO: error handling
        except Exception as e:
            print("crap!")

if __name__ == '__main__':
    orderMatcher = OrderMatcher()
    while True:
        orderMatcher.match_orders()
        time.sleep(INTERVAL)
